
--Written by "ihc-433" 
--Update by "Werkstattleiter" und "Ordaton"  NAS-Moddingsquad
--Angepasst fr TLF 16/25 by "Grisu118"
--Date: 05.05.2013

TLF16_25 = {};

function TLF16_25.prerequisitesPresent(specializations)
    return true; 
end;

function TLF16_25:load(xmlFile)
		--Erster Trigger
	self.Trigger1 = TLF16_25.Trigger1;
	self.TriggerIndex1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Trigger1#index"));
	addTrigger(self.TriggerIndex1, "Trigger1", self);
	self.enteredTrigger1 = false;
		--Zweiter Trigger
	self.Trigger2 = TLF16_25.Trigger2;
	self.TriggerIndex2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Trigger2#index"));
	addTrigger(self.TriggerIndex2, "Trigger2", self);
	self.enteredTrigger2 = false;
		--dritter Trigger
	self.Trigger3 = TLF16_25.Trigger3;
	self.TriggerIndex3 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Trigger3#index"));
	addTrigger(self.TriggerIndex3, "Trigger3", self);
	self.enteredTrigger3 = false;
		--Vierter Trigger
	self.Trigger4 = TLF16_25.Trigger4;
	self.TriggerIndex4 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Trigger4#index"));
	addTrigger(self.TriggerIndex4, "Trigger4", self);
	self.enteredTrigger4 = false;
		--fnfter Trigger
	self.Trigger5 = TLF16_25.Trigger5;
	self.TriggerIndex5 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Trigger5#index"));
	addTrigger(self.TriggerIndex5, "Trigger5", self);
	self.enteredTrigger5 = false;
		--sechster Trigger
	self.Trigger6 = TLF16_25.Trigger6;
	self.TriggerIndex6 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Trigger6#index"));
	addTrigger(self.TriggerIndex6, "Trigger6", self);
	self.enteredTrigger6 = false;
		--siebter Trigger
	self.Trigger7 = TLF16_25.Trigger7;
	self.TriggerIndex7 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Trigger7#index"));
	addTrigger(self.TriggerIndex7, "Trigger7", self);
	self.enteredTrigger7 = false;
	
	
	local hydraulicsCount = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.hydraulics#count"), 0);	
	self.hydraulics = {};	
	for i=1, hydraulicsCount do
		local hydraulicName = string.format("vehicle.hydraulics.hydraulic%d", i);		
		self.hydraulics[i] = {};		
		self.hydraulics[i].node = Utils.indexToObject(self.components, getXMLString(xmlFile, hydraulicName .. "#index"));
		self.hydraulics[i].punch = Utils.indexToObject(self.components, getXMLString(xmlFile, hydraulicName .. "#punch"));
		self.hydraulics[i].translationPunch = Utils.indexToObject(self.components, getXMLString(xmlFile, hydraulicName .. "#punchFixpoint"));
		self.hydraulics[i].fixPoint = Utils.indexToObject(self.components, getXMLString(xmlFile, hydraulicName .. "#fixpoint"));
		if self.hydraulics[i].punch ~= nil and self.hydraulics[i].translationPunch ~= nil then
			local ax, ay, az = getWorldTranslation(self.hydraulics[i].punch);
			local bx, by, bz = getWorldTranslation(self.hydraulics[i].translationPunch);		
			self.hydraulics[i].punchDistance = Utils.vector3Length(ax-bx, ay-by, az-bz);
		end;
	end;
	
end;

function TLF16_25:Trigger1(triggerId, otherId, onEnter, onLeave, onStay, otherShapeId)
	if (g_currentMission.controlledVehicle and otherId == g_currentMission.controlledVehicle.components[1].node) or (g_currentMission.player and otherId == g_currentMission.player.rootNode) then
		if onEnter then
			self.enteredTrigger1 = true;
		end;
	if onLeave then 
		self.enteredTrigger1 = false;
		end;
	end;
end;
function TLF16_25:Trigger2(triggerId, otherId, onEnter, onLeave, onStay, otherShapeId)
	if (g_currentMission.controlledVehicle and otherId == g_currentMission.controlledVehicle.components[1].node) or (g_currentMission.player and otherId == g_currentMission.player.rootNode) then
		if onEnter then
			self.enteredTrigger2 = true;
		end;
	if onLeave then 
		self.enteredTrigger2 = false;
		end;
	end;
end;
function TLF16_25:Trigger3(triggerId, otherId, onEnter, onLeave, onStay, otherShapeId)
	if (g_currentMission.controlledVehicle and otherId == g_currentMission.controlledVehicle.components[1].node) or (g_currentMission.player and otherId == g_currentMission.player.rootNode) then
		if onEnter then
			self.enteredTrigger3 = true;
		end;
	if onLeave then 
		self.enteredTrigger3 = false;
		end;
	end;
end;
function TLF16_25:Trigger4(triggerId, otherId, onEnter, onLeave, onStay, otherShapeId)
	if (g_currentMission.controlledVehicle and otherId == g_currentMission.controlledVehicle.components[1].node) or (g_currentMission.player and otherId == g_currentMission.player.rootNode) then
		if onEnter then
			self.enteredTrigger4 = true;
		end;
	if onLeave then 
		self.enteredTrigger4 = false;
		end;
	end;
end;
function TLF16_25:Trigger5(triggerId, otherId, onEnter, onLeave, onStay, otherShapeId)
	if (g_currentMission.controlledVehicle and otherId == g_currentMission.controlledVehicle.components[1].node) or (g_currentMission.player and otherId == g_currentMission.player.rootNode) then
		if onEnter then
			self.enteredTrigger5 = true;
		end;
	if onLeave then 
		self.enteredTrigger5 = false;
		end;
	end;
end;
function TLF16_25:Trigger6(triggerId, otherId, onEnter, onLeave, onStay, otherShapeId)
	if (g_currentMission.controlledVehicle and otherId == g_currentMission.controlledVehicle.components[1].node) or (g_currentMission.player and otherId == g_currentMission.player.rootNode) then
		if onEnter then
			self.enteredTrigger6 = true;
		end;
	if onLeave then 
		self.enteredTrigger6 = false;
		end;
	end;
end;
function TLF16_25:Trigger7(triggerId, otherId, onEnter, onLeave, onStay, otherShapeId)
	if (g_currentMission.controlledVehicle and otherId == g_currentMission.controlledVehicle.components[1].node) or (g_currentMission.player and otherId == g_currentMission.player.rootNode) then
		if onEnter then
			self.enteredTrigger7 = true;
		end;
	if onLeave then 
		self.enteredTrigger7 = false;
		end;
	end;
end;

function TLF16_25:readStream(streamId, connection)
	
end;

function TLF16_25:writeStream(streamId, connection)	
	
end;

function TLF16_25:delete()
	removeTrigger(self.TriggerIndex1, "Trigger1", self);
	removeTrigger(self.TriggerIndex2, "Trigger2", self);
	removeTrigger(self.TriggerIndex3, "Trigger3", self);
	removeTrigger(self.TriggerIndex4, "Trigger4", self);
	removeTrigger(self.TriggerIndex5, "Trigger5", self);
	removeTrigger(self.TriggerIndex6, "Trigger6", self);
	removeTrigger(self.TriggerIndex7, "Trigger7", self);
	
end

function TLF16_25:mouseEvent(posX, posY, isDown, isUp, button)
end;

function TLF16_25:keyEvent(unicode, sym, modifier, isDown)
end;

function TLF16_25:update(dt)
	if self.enteredTrigger1 then 
		if InputBinding.isPressed(InputBinding.TLF16_25_3) then 
			self:setAnimationTime(1, self.animationParts[1].currentPosition+(self.animationParts[1].offSet*(dt/5)));
		end;
		if InputBinding.isPressed(InputBinding.TLF16_25_4) then 
			self:setAnimationTime(1, self.animationParts[1].currentPosition-(self.animationParts[1].offSet*(dt/5)));
		end;		
		if self.animationParts[1].clip then
					g_currentMission:addHelpButtonText(string.format(g_i18n:getText("TLF16_25_3")), InputBinding.TLF16_25_3);
					g_currentMission:addHelpButtonText(string.format(g_i18n:getText("TLF16_25_4")), InputBinding.TLF16_25_4);
		end;		
	end;
	if self.enteredTrigger2 then
		if InputBinding.isPressed(InputBinding.TLF16_25_1) then 
			self:setAnimationTime(2, self.animationParts[2].currentPosition+(self.animationParts[2].offSet*(dt/5)));
		end;
		if InputBinding.isPressed(InputBinding.TLF16_25_2) then 
			self:setAnimationTime(2, self.animationParts[2].currentPosition-(self.animationParts[2].offSet*(dt/5)));
		end;
		if self.animationParts[2].clip then
					g_currentMission:addHelpButtonText(string.format(g_i18n:getText("TLF16_25_1")), InputBinding.TLF16_25_1);
					g_currentMission:addHelpButtonText(string.format(g_i18n:getText("TLF16_25_2")), InputBinding.TLF16_25_2);
		end;		
	end;
	if self.enteredTrigger3 then
		if InputBinding.isPressed(InputBinding.TLF16_25_1) then 
			self:setAnimationTime(3, self.animationParts[3].currentPosition+(self.animationParts[3].offSet*(dt/5)));
		end;
		if InputBinding.isPressed(InputBinding.TLF16_25_2) then 
			self:setAnimationTime(3, self.animationParts[3].currentPosition-(self.animationParts[3].offSet*(dt/5)));
		end;
		if self.animationParts[3].clip then
					g_currentMission:addHelpButtonText(string.format(g_i18n:getText("TLF16_25_1")), InputBinding.TLF16_25_1);
					g_currentMission:addHelpButtonText(string.format(g_i18n:getText("TLF16_25_2")), InputBinding.TLF16_25_2);
		end;		
	end;
	if self.enteredTrigger4 then
		if InputBinding.isPressed(InputBinding.TLF16_25_1) then 
			self:setAnimationTime(4, self.animationParts[4].currentPosition+(self.animationParts[4].offSet*(dt/5)));
		end;
		if InputBinding.isPressed(InputBinding.TLF16_25_2) then 
			self:setAnimationTime(4, self.animationParts[4].currentPosition-(self.animationParts[4].offSet*(dt/5)));
		end;
		if self.animationParts[4].clip then
					g_currentMission:addHelpButtonText(string.format(g_i18n:getText("TLF16_25_5")), InputBinding.TLF16_25_1);
					g_currentMission:addHelpButtonText(string.format(g_i18n:getText("TLF16_25_6")), InputBinding.TLF16_25_2);
		end;		
	end;
	if self.enteredTrigger5 then
		if InputBinding.isPressed(InputBinding.TLF16_25_1) then 
			self:setAnimationTime(5, self.animationParts[5].currentPosition+(self.animationParts[5].offSet*(dt/5)));
		end;
		if InputBinding.isPressed(InputBinding.TLF16_25_2) then 
			self:setAnimationTime(5, self.animationParts[5].currentPosition-(self.animationParts[5].offSet*(dt/5)));
		end;
		if self.animationParts[5].clip then
					g_currentMission:addHelpButtonText(string.format(g_i18n:getText("TLF16_25_5")), InputBinding.TLF16_25_1);
					g_currentMission:addHelpButtonText(string.format(g_i18n:getText("TLF16_25_6")), InputBinding.TLF16_25_2);
		end;		
	end;
	if self.enteredTrigger6 then
		if InputBinding.isPressed(InputBinding.TLF16_25_1) then 
			self:setAnimationTime(6, self.animationParts[6].currentPosition+(self.animationParts[6].offSet*(dt/5)));
		end;
		if InputBinding.isPressed(InputBinding.TLF16_25_2) then 
			self:setAnimationTime(6, self.animationParts[6].currentPosition-(self.animationParts[6].offSet*(dt/5)));
		end;
		if self.animationParts[6].clip then
					g_currentMission:addHelpButtonText(string.format(g_i18n:getText("TLF16_25_7")), InputBinding.TLF16_25_1);
					g_currentMission:addHelpButtonText(string.format(g_i18n:getText("TLF16_25_8")), InputBinding.TLF16_25_2);
		end;		
	end;
	if self.enteredTrigger7 then
		if InputBinding.isPressed(InputBinding.TLF16_25_1) then 
			self:setAnimationTime(7, self.animationParts[7].currentPosition+(self.animationParts[7].offSet*(dt/5)));
		end;
		if InputBinding.isPressed(InputBinding.TLF16_25_2) then 
			self:setAnimationTime(7, self.animationParts[7].currentPosition-(self.animationParts[7].offSet*(dt/5)));
		end;
		if self.animationParts[7].clip then
					g_currentMission:addHelpButtonText(string.format(g_i18n:getText("TLF16_25_7")), InputBinding.TLF16_25_1);
					g_currentMission:addHelpButtonText(string.format(g_i18n:getText("TLF16_25_8")), InputBinding.TLF16_25_2);
		end;		
	end;
	
	
end;

function TLF16_25:triggerCallback(triggerId,otherId,onEnter,onLeave,onStay)
    if (triggerId == self.stateChange) then
        if (onEnter and g_currentMission.controlPlayer and g_currentMission.player ~= nil and otherId == g_currentMission.player.rootNode) then
            self.changeAllowed = true;
        elseif (onLeave) then
            self.changeAllowed = false;
        end;
    end;
end;

function TLF16_25:updateTick(dt)

	for i=1, table.getn(self.hydraulics) do
		local ax, ay, az = getWorldTranslation(self.hydraulics[i].node);
		local bx, by, bz = getWorldTranslation(self.hydraulics[i].fixPoint);
		if bx ~= nil and by ~= nil and bz ~= nil then
			local x, y, z = worldDirectionToLocal(getParent(self.hydraulics[i].node), bx-ax, by-ay, bz-az);
			setDirection(self.hydraulics[i].node, x, y, z, 0, 0, 1);
			local distance = Utils.vector3Length(ax-bx, ay-by, az-bz);
			if self.hydraulics[i].punch ~= nil and self.hydraulics[i].punchDistance ~= nil and self.hydraulics[i].translationPunch then
				if self.hydraulics[i].doScale then
					local xScale, yScale, zScale = getScale(self.hydraulics[i].punch);
					local newScale = xScale * (distance / self.hydraulics[i].punchDistance);
					setScale(self.hydraulics[i].punch, 1, 1, newScale);
				else
					setTranslation(self.hydraulics[i].punch, 0, 0, distance-self.hydraulics[i].punchDistance);
				end;
			end;
		end;
	end;
	
end;

function TLF16_25:draw()
	


end;

function TLF16_25:onLeave()
	
end;